#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       bz2compressor.py
#       
#       Copyright 2013 Recursos Python - www.recursospython.com
#       
#       

from sys import argv
from os.path import exists

import bz2


def read_file(filename):
    try:
        f = open(filename, "rb")
    except IOError, e:
        print e.errno, e.message
    else:
        data = f.read()
        f.close()
        return data


def write_file(filename, data):
    try:
        f = open(filename, "wb")
    except IOError, e:
        print e.errno, e.message
    else:
        f.write(data)
        f.close()


def compress(filename):
    data = read_file(filename)
    
    if data is not None:
        f = open(filename + ".bz2", "wb")
        f.write(bz2.compress(data))
        f.close()


def decompress(filename):
    data = read_file(filename)
    
    if data is not None:
        write_file(filename[:filename.rfind(".bz2")],
                   bz2.decompress(data))


def main():
    argc = len(argv)
    
    if argc > 1:
        for filename in argv[1:]:
            if exists(filename):
                if filename.lower().endswith(".bz2"):
                    decompress(filename)
                else:
                    compress(filename)
            else:
                print "No se ha encontrado %s." % filename
    else:
        print u"No se ha encontrado ningún archivo."
    

if __name__ == "__main__":
    main()
